<?







class MinibrowserComponent extends FormComponent {

 var $d_minibrowser;

 function MinibrowserComponent(&$mbwrapper) {
 parent::FormComponent();
 $this->d_minibrowser =& $mbwrapper;
 }

 function setFolder($id, $type) {
 $mb =& $this->d_minibrowser->getMinibrowser();
 $mb->setFolder($id, $type);
 }

 function getFolderID() {
 $mb =& $this->d_minibrowser->getMinibrowser();
 return $mb->getFolderID();
 }

 function getFolderType() {
 $mb =& $this->d_minibrowser->getMinibrowser();
 return $mb->getFolderType();
 }

 function setResult($step, $value) {
 $mb =& $this->d_minibrowser->getMinibrowser();
 $mb->setResultID($step, $value);
 }

 function getResult($step = "") {
 $mb =& $this->d_minibrowser->getMinibrowser();
 return $mb->getResultID($step);
 }


 function &getResultObject() {
 return $this->d_minibrowser->getResultObject();
 }

 function setObject(&$obj) {
 $this->d_minibrowser->setObject($obj);
 }

 function isFinished() {
 $mb =& $this->d_minibrowser->getMinibrowser();
 return ($mb->isFinished());
 }

 function getHTML( &$form, $fieldPrefix, $doCheck, $checkSeverity, $key ) {
 
 $mb =& $this->d_minibrowser->getMinibrowser();

 $mb->initFromSubmit();

 
 $mb->setLinkParams($urlAdd);
 
 return $this->mergeResult( parent::getHTML($form, $fieldPrefix, $doCheck, $checkSeverity, $key), $mb->getHTML() );
 }

 function getProperty( $key ) {
 $class =& $this->d_minibrowser->getResultObject();
 if (is_object($class) && method_exists($class, "getProperty")) {
 return $class->getProperty( $key );
 } else {
 return new NodeException("No Result selected or getProperty not supported.");
 }
 }

 function toString() {
 return $this->d_minibrowser->getText();
 }
 
 function onLoadFinished()
 {
 parent::onLoadFinished();
 }
 
 function getSerializeKey() 
 {
 $ret = parent::getSerializeKey();
 $ret["MinibrowserHiSelector§"] = array(
 node_serialize($this->d_minibrowser)
 );
 return $ret;
 }
 
 function initFromSerializeKey( $sKey ) 
 {
 parent::initFromSerializeKey($sKey);
 $key = $sKey["MinibrowserHiSelector§"];
 $this->d_minibrowser = &node_unserialize($key[1]);
 }
 
}

class MinibrowserWrapper extends BaseObject {

 function MinibrowserWrapper() {
 }
 
 function &getMinibrowser() {
 }
 
 function getText() {
 }
 
 function getResultObject() {
 }
 
 function setObject(&$obj) {
 }

 function initObject($type, $id) {
 }

 function getObjectType() {
 }

 function getObjectID() {
 }
}

class MinibrowserSimpleTree extends MinibrowserWrapper {

 var $root_id, $root_type;
 var $types;
 var $d_mb;

 function MinibrowserSimpleTree($root_id, $root_type) {
 $this->root_id = $root_id;
 $this->root_type = $root_type;
 $this->types = array();
 $this->initMinibrowser();
 }
 
 function setTType($type, $nodeobject) {
 $this->types[$type] = node_serialize($nodeobject);
 $this->d_mb->addType($type);
 }
 
 function unsetTType($type) {
 $this->types[$type] = false;
 $this->d_mb->delType($type);
 }

 function setFolder($o_type, $o_id) {
 $this->d_mb->setFolder($o_id, $o_type);
 }

 function &getMinibrowser() {
 return $this->d_mb;
 }

 function initMinibrowser() {
 node_class("minibrowser");
 node_var("T_TYPE");
 $this->d_mb = new MiniBrowser($this->root_id, $this->root_type);
 }

 function getText() {
 node_func("tree_get_name");
 return tree_get_name($this->d_mb->getFolderType(), $this->d_mb->getFolderID() ,$this->d_mb->getTType());
 }

 function getResultObject() {
 $type = $this->d_mb->getFolderType();
 if ($this->types[$type]) {
 $obj = &node_unserialize($this->types[$type]);
 $obj->setID($this->d_mb->getFolderID());
 return $obj;
 } else {
 return new NodeObject(0);
 }
 }

 function setObject(&$obj) {
 $this->setFolder($obj->getTType(), $obj->getID());
 }

}

?>
