<?php





















































$GLOBALS['_transient']['static']['nusoap_base']->globalDebugLevel = 9;









class nusoap_base {
 





 var $title = 'NuSOAP';
 





 var $version = '0.7.2';
 





 var $revision = '$Revision: 1.2 $';
 





 var $error_str = '';
 





 var $debug_str = '';
 






 var $charencoding = true;
 





 var $debugLevel;

 





 var $XMLSchemaVersion = 'http://www.w3.org/2001/XMLSchema';
 
 





 var $soap_defencoding = 'ISO-8859-1';
 

 







 var $namespaces = array(
 'SOAP-ENV' => 'http://schemas.xmlsoap.org/soap/envelope/',
 'xsd' => 'http://www.w3.org/2001/XMLSchema',
 'xsi' => 'http://www.w3.org/2001/XMLSchema-instance',
 'SOAP-ENC' => 'http://schemas.xmlsoap.org/soap/encoding/'
 );

 





 var $usedNamespaces = array();

 






 var $typemap = array(
 'http://www.w3.org/2001/XMLSchema' => array(
 'string'=>'string','boolean'=>'boolean','float'=>'double','double'=>'double','decimal'=>'double',
 'duration'=>'','dateTime'=>'string','time'=>'string','date'=>'string','gYearMonth'=>'',
 'gYear'=>'','gMonthDay'=>'','gDay'=>'','gMonth'=>'','hexBinary'=>'string','base64Binary'=>'string',
 
 'anyType'=>'string','anySimpleType'=>'string',
 
 'normalizedString'=>'string','token'=>'string','language'=>'','NMTOKEN'=>'','NMTOKENS'=>'','Name'=>'','NCName'=>'','ID'=>'',
 'IDREF'=>'','IDREFS'=>'','ENTITY'=>'','ENTITIES'=>'','integer'=>'integer','nonPositiveInteger'=>'integer',
 'negativeInteger'=>'integer','long'=>'integer','int'=>'integer','short'=>'integer','byte'=>'integer','nonNegativeInteger'=>'integer',
 'unsignedLong'=>'','unsignedInt'=>'','unsignedShort'=>'','unsignedByte'=>'','positiveInteger'=>''),
 'http://www.w3.org/2000/10/XMLSchema' => array(
 'i4'=>'','int'=>'integer','boolean'=>'boolean','string'=>'string','double'=>'double',
 'float'=>'double','dateTime'=>'string',
 'timeInstant'=>'string','base64Binary'=>'string','base64'=>'string','ur-type'=>'array'),
 'http://www.w3.org/1999/XMLSchema' => array(
 'i4'=>'','int'=>'integer','boolean'=>'boolean','string'=>'string','double'=>'double',
 'float'=>'double','dateTime'=>'string',
 'timeInstant'=>'string','base64Binary'=>'string','base64'=>'string','ur-type'=>'array'),
 'http://soapinterop.org/xsd' => array('SOAPStruct'=>'struct'),
 'http://schemas.xmlsoap.org/soap/encoding/' => array('base64'=>'string','array'=>'array','Array'=>'array'),
 'http://xml.apache.org/xml-soap' => array('Map')
 );

 







 var $xmlEntities = array('quot' => '"','amp' => '&',
 'lt' => '<','gt' => '>','apos' => "'");

 




 function nusoap_base() {
 $this->debugLevel = $GLOBALS['_transient']['static']['nusoap_base']->globalDebugLevel;
 }

 





 function getGlobalDebugLevel() {
 return $GLOBALS['_transient']['static']['nusoap_base']->globalDebugLevel;
 }

 





 function setGlobalDebugLevel($level) {
 $GLOBALS['_transient']['static']['nusoap_base']->globalDebugLevel = $level;
 }

 





 function getDebugLevel() {
 return $this->debugLevel;
 }

 





 function setDebugLevel($level) {
 $this->debugLevel = $level;
 }

 





 function debug($string){
 if ($this->debugLevel > 0) {
 $this->appendDebug($this->getmicrotime().' '.get_class($this).": $string\n");
 }
 }

 





 function appendDebug($string){
 if ($this->debugLevel > 0) {
 
 
 $this->debug_str .= $string;
 }
 }

 




 function clearDebug() {
 
 
 $this->debug_str = '';
 }

 





 function &getDebug() {
 
 
 return $this->debug_str;
 }

 






 function &getDebugAsXMLComment() {
 
 
 while (strpos($this->debug_str, '--')) {
 $this->debug_str = str_replace('--', '- -', $this->debug_str);
 }
 return "<!--\n" . $this->debug_str . "\n-->";
 }

 





 function expandEntities($val) {
 if ($this->charencoding) {
 $val = str_replace('&', '&amp;', $val);
 $val = str_replace("'", '&apos;', $val);
 $val = str_replace('"', '&quot;', $val);
 $val = str_replace('<', '&lt;', $val);
 $val = str_replace('>', '&gt;', $val);
 }
 return $val;
 }

 





 function getError(){
 if($this->error_str != ''){
 return $this->error_str;
 }
 return false;
 }

 





 function setError($str){
 $this->error_str = $str;
 }

 






 function isArraySimpleOrStruct($val) {
 $keyList = array_keys($val);
 foreach ($keyList as $keyListValue) {
 if (!is_int($keyListValue)) {
 return 'arrayStruct';
 }
 }
 return 'arraySimple';
 }

 













 function serialize_val($val,$name=false,$type=false,$name_ns=false,$type_ns=false,$attributes=false,$use='encoded'){
 $this->debug("in serialize_val: name=$name, type=$type, name_ns=$name_ns, type_ns=$type_ns, use=$use");
 $this->appendDebug('value=' . $this->varDump($val));
 $this->appendDebug('attributes=' . $this->varDump($attributes));
 
 if(is_object($val) && get_class($val) == 'soapval'){
 return $val->serialize($use);
 }
 
 if (is_numeric($name)) {
 $name = '__numeric_' . $name;
 } elseif (! $name) {
 $name = 'noname';
 }
 
 $xmlns = '';
 if($name_ns){
 $prefix = 'nu'.rand(1000,9999);
 $name = $prefix.':'.$name;
 $xmlns .= " xmlns:$prefix=\"$name_ns\"";
 }
 
 if($type_ns != '' && $type_ns == $this->namespaces['xsd']){
 
 
 $type_prefix = 'xsd';
 } elseif($type_ns){
 $type_prefix = 'ns'.rand(1000,9999);
 $xmlns .= " xmlns:$type_prefix=\"$type_ns\"";
 }
 
 $atts = '';
 if($attributes){
 foreach($attributes as $k => $v){
 $atts .= " $k=\"".$this->expandEntities($v).'"';
 }
 }
 
 if (is_null($val)) {
 if ($use == 'literal') {
 
 return "<$name$xmlns $atts/>";
 } else {
 if (isset($type) && isset($type_prefix)) {
 $type_str = " xsi:type=\"$type_prefix:$type\"";
 } else {
 $type_str = '';
 }
 return "<$name$xmlns$type_str $atts xsi:nil=\"true\"/>";
 }
 }
 
 if($type != '' && isset($this->typemap[$this->XMLSchemaVersion][$type])){
 if (is_bool($val)) {
 if ($type == 'boolean') {
 $val = $val ? 'true' : 'false';
 } elseif (! $val) {
 $val = 0;
 }
 } else if (is_string($val)) {
 $val = $this->expandEntities($val);
 }
 if ($use == 'literal') {
 return "<$name$xmlns $atts>$val</$name>";
 } else {
 return "<$name$xmlns $atts xsi:type=\"xsd:$type\">$val</$name>";
 }
 }
 
 $xml = '';
 switch(true) {
 case (is_bool($val) || $type == 'boolean'):
 if ($type == 'boolean') {
 $val = $val ? 'true' : 'false';
 } elseif (! $val) {
 $val = 0;
 }
 if ($use == 'literal') {
 $xml .= "<$name$xmlns $atts>$val</$name>";
 } else {
 $xml .= "<$name$xmlns xsi:type=\"xsd:boolean\"$atts>$val</$name>";
 }
 break;
 case (is_int($val) || is_long($val) || $type == 'int'):
 if ($use == 'literal') {
 $xml .= "<$name$xmlns $atts>$val</$name>";
 } else {
 $xml .= "<$name$xmlns xsi:type=\"xsd:int\"$atts>$val</$name>";
 }
 break;
 case (is_float($val)|| is_double($val) || $type == 'float'):
 if ($use == 'literal') {
 $xml .= "<$name$xmlns $atts>$val</$name>";
 } else {
 $xml .= "<$name$xmlns xsi:type=\"xsd:float\"$atts>$val</$name>";
 }
 break;
 case (is_string($val) || $type == 'string'):
 $val = $this->expandEntities($val);
 if ($use == 'literal') {
 $xml .= "<$name$xmlns $atts>$val</$name>";
 } else {
 $xml .= "<$name$xmlns xsi:type=\"xsd:string\"$atts>$val</$name>";
 }
 break;
 case is_object($val):
 if (! $name) {
 $name = get_class($val);
 $this->debug("In serialize_val, used class name $name as element name");
 } else {
 $this->debug("In serialize_val, do not override name $name for element name for class " . get_class($val));
 }
 foreach(get_object_vars($val) as $k => $v){
 $pXml = isset($pXml) ? $pXml.$this->serialize_val($v,$k,false,false,false,false,$use) : $this->serialize_val($v,$k,false,false,false,false,$use);
 }
 $xml .= '<'.$name.'>'.$pXml.'</'.$name.'>';
 break;
 break;
 case (is_array($val) || $type):
 
 $valueType = $this->isArraySimpleOrStruct($val);
 if($valueType=='arraySimple' || ereg('^ArrayOf',$type)){
 $i = 0;
 if(is_array($val) && count($val)> 0){
 foreach($val as $v){
 if(is_object($v) && get_class($v) == 'soapval'){
 $tt_ns = $v->type_ns;
 $tt = $v->type;
 } elseif (is_array($v)) {
 $tt = $this->isArraySimpleOrStruct($v);
 } else {
 $tt = gettype($v);
 }
 $array_types[$tt] = 1;
 
 $xml .= $this->serialize_val($v,'item',false,false,false,false,$use);
 ++$i;
 }
 if(count($array_types) > 1){
 $array_typename = 'xsd:anyType';
 } elseif(isset($tt) && isset($this->typemap[$this->XMLSchemaVersion][$tt])) {
 if ($tt == 'integer') {
 $tt = 'int';
 }
 $array_typename = 'xsd:'.$tt;
 } elseif(isset($tt) && $tt == 'arraySimple'){
 $array_typename = 'SOAP-ENC:Array';
 } elseif(isset($tt) && $tt == 'arrayStruct'){
 $array_typename = 'unnamed_struct_use_soapval';
 } else {
 
 if ($tt_ns != '' && $tt_ns == $this->namespaces['xsd']){
 $array_typename = 'xsd:' . $tt;
 } elseif ($tt_ns) {
 $tt_prefix = 'ns' . rand(1000, 9999);
 $array_typename = "$tt_prefix:$tt";
 $xmlns .= " xmlns:$tt_prefix=\"$tt_ns\"";
 } else {
 $array_typename = $tt;
 }
 }
 $array_type = $i;
 if ($use == 'literal') {
 $type_str = '';
 } else if (isset($type) && isset($type_prefix)) {
 $type_str = " xsi:type=\"$type_prefix:$type\"";
 } else {
 $type_str = " xsi:type=\"SOAP-ENC:Array\" SOAP-ENC:arrayType=\"".$array_typename."[$array_type]\"";
 }
 
 } else {
 if ($use == 'literal') {
 $type_str = '';
 } else if (isset($type) && isset($type_prefix)) {
 $type_str = " xsi:type=\"$type_prefix:$type\"";
 } else {
 $type_str = " xsi:type=\"SOAP-ENC:Array\" SOAP-ENC:arrayType=\"xsd:anyType[0]\"";
 }
 }
 
 $xml = "<$name$xmlns$type_str$atts>".$xml."</$name>";
 } else {
 
 if(isset($type) && isset($type_prefix)){
 $type_str = " xsi:type=\"$type_prefix:$type\"";
 } else {
 $type_str = '';
 }
 if ($use == 'literal') {
 $xml .= "<$name$xmlns $atts>";
 } else {
 $xml .= "<$name$xmlns$type_str$atts>";
 }
 foreach($val as $k => $v){
 
 if ($type == 'Map' && $type_ns == 'http://xml.apache.org/xml-soap') {
 $xml .= '<item>';
 $xml .= $this->serialize_val($k,'key',false,false,false,false,$use);
 $xml .= $this->serialize_val($v,'value',false,false,false,false,$use);
 $xml .= '</item>';
 } else {
 $xml .= $this->serialize_val($v,$k,false,false,false,false,$use);
 }
 }
 $xml .= "</$name>";
 }
 break;
 default:
 $xml .= 'not detected, got '.gettype($val).' for '.$val;
 break;
 }
 return $xml;
 }

 











 function serializeEnvelope($body,$headers=false,$namespaces=array(),$style='rpc',$use='encoded',$encodingStyle='http://schemas.xmlsoap.org/soap/encoding/'){
 
 
 

 $this->debug("In serializeEnvelope length=" . strlen($body) . " body (max 1000 characters)=" . substr($body, 0, 1000) . " style=$style use=$use encodingStyle=$encodingStyle");
 $this->debug("headers:");
 $this->appendDebug($this->varDump($headers));
 $this->debug("namespaces:");
 $this->appendDebug($this->varDump($namespaces));

 
 $ns_string = '';
 foreach(array_merge($this->namespaces,$namespaces) as $k => $v){
 $ns_string .= " xmlns:$k=\"$v\"";
 }
 if($encodingStyle) {
 $ns_string = " SOAP-ENV:encodingStyle=\"$encodingStyle\"$ns_string";
 }

 
 if($headers){
 if (is_array($headers)) {
 $xml = '';
 foreach ($headers as $header) {
 $xml .= $this->serialize_val($header, false, false, false, false, false, $use);
 }
 $headers = $xml;
 $this->debug("In serializeEnvelope, serialzied array of headers to $headers");
 }
 $headers = "<SOAP-ENV:Header>".$headers."</SOAP-ENV:Header>";
 }
 
 return
 '<?xml version="1.0" encoding="'.$this->soap_defencoding .'"?'.">".
 '<SOAP-ENV:Envelope'.$ns_string.">".
 $headers.
 "<SOAP-ENV:Body>".
 $body.
 "</SOAP-ENV:Body>".
 "</SOAP-ENV:Envelope>";
 }

 







 function formatDump($str){
 $str = htmlspecialchars($str);
 return nl2br($str);
 }

 






 function contractQname($qname){
 
 
 if (strrpos($qname, ':')) {
 
 $name = substr($qname, strrpos($qname, ':') + 1);
 
 $ns = substr($qname, 0, strrpos($qname, ':'));
 $p = $this->getPrefixFromNamespace($ns);
 if ($p) {
 return $p . ':' . $name;
 }
 return $qname;
 } else {
 return $qname;
 }
 }

 






 function expandQname($qname){
 
 if(strpos($qname,':') && !ereg('^http://',$qname)){
 
 $name = substr(strstr($qname,':'),1);
 
 $prefix = substr($qname,0,strpos($qname,':'));
 if(isset($this->namespaces[$prefix])){
 return $this->namespaces[$prefix].':'.$name;
 } else {
 return $qname;
 }
 } else {
 return $qname;
 }
 }

 







 function getLocalPart($str){
 if($sstr = strrchr($str,':')){
 
 return substr( $sstr, 1 );
 } else {
 return $str;
 }
 }

 







 function getPrefix($str){
 if($pos = strrpos($str,':')){
 
 return substr($str,0,$pos);
 }
 return false;
 }

 






 function getNamespaceFromPrefix($prefix){
 if (isset($this->namespaces[$prefix])) {
 return $this->namespaces[$prefix];
 }
 
 return false;
 }

 







 function getPrefixFromNamespace($ns) {
 foreach ($this->namespaces as $p => $n) {
 if ($ns == $n || $ns == $p) {
 $this->usedNamespaces[$p] = $n;
 return $p;
 }
 }
 return false;
 }

 





 function getmicrotime() {
 if (function_exists('gettimeofday')) {
 $tod = gettimeofday();
 $sec = $tod['sec'];
 $usec = $tod['usec'];
 } else {
 $sec = time();
 $usec = 0;
 }
 return strftime('%Y-%m-%d %H:%M:%S', $sec) . '.' . sprintf('%06d', $usec);
 }

 






 function varDump($data) {
 ob_start();
 var_dump($data);
 $ret_val = ob_get_contents();
 ob_end_clean();
 return $ret_val;
 }
}











function timestamp_to_iso8601($timestamp,$utc=true){
 $datestr = date('Y-m-d\TH:i:sO',$timestamp);
 if($utc){
 $eregStr =
 '([0-9]{4})-'. 
 '([0-9]{2})-'. 
 '([0-9]{2})'. 
 'T'. 
 '([0-9]{2}):'. 
 '([0-9]{2}):'. 
 '([0-9]{2})(\.[0-9]*)?'. 
 '(Z|[+\-][0-9]{2}:?[0-9]{2})?'; 

 if(ereg($eregStr,$datestr,$regs)){
 return sprintf('%04d-%02d-%02dT%02d:%02d:%02dZ',$regs[1],$regs[2],$regs[3],$regs[4],$regs[5],$regs[6]);
 }
 return false;
 } else {
 return $datestr;
 }
}







function iso8601_to_timestamp($datestr){
 $eregStr =
 '([0-9]{4})-'. 
 '([0-9]{2})-'. 
 '([0-9]{2})'. 
 'T'. 
 '([0-9]{2}):'. 
 '([0-9]{2}):'. 
 '([0-9]{2})(\.[0-9]+)?'. 
 '(Z|[+\-][0-9]{2}:?[0-9]{2})?'; 
 if(ereg($eregStr,$datestr,$regs)){
 
 if($regs[8] != 'Z'){
 $op = substr($regs[8],0,1);
 $h = substr($regs[8],1,2);
 $m = substr($regs[8],strlen($regs[8])-2,2);
 if($op == '-'){
 $regs[4] = $regs[4] + $h;
 $regs[5] = $regs[5] + $m;
 } elseif($op == '+'){
 $regs[4] = $regs[4] - $h;
 $regs[5] = $regs[5] - $m;
 }
 }
 return strtotime("$regs[1]-$regs[2]-$regs[3] $regs[4]:$regs[5]:$regs[6]Z");
 } else {
 return false;
 }
}








function usleepWindows($usec)
{
 $start = gettimeofday();
 
 do
 {
 $stop = gettimeofday();
 $timePassed = 1000000 * ($stop['sec'] - $start['sec'])
 + $stop['usec'] - $start['usec'];
 }
 while ($timePassed < $usec);
}


?>