<?

function part_genform($parts, $clear_vars = false) {

if (!$parts) halt(0,"part_genform: no parts to transform to formelements: parts($parts)");

global $HI, $DIC, $ICO_MINI, $ICO_PAGE_OFF, $ICO_WORD, $NODE_ID, $LANGUAGE, $ICO_SPELL, $FEATURE, $JEDIT_FIELDS, 
 $CN_TEXTLONG_ROWS, $CN_TEXTLONG_COLS, $CN_TEXTSHORT_SIZE, $CN_TEXT_ROWS, $CN_TEXT_COLS;


while (list($key,$part) = each($parts)) {
 $type = $part["type_id"];
 $partorder = $part["partorder"];
 $keyword = $part["keyword"];
 $id = $part["id"];
 $name = $part["name"];
 $required = $part["required"];
 $info_int = $part["info_int"];
 $info_text = $part["info_text"];
 if ($required) $optional = false;
 if (!$required) $optional = true;


 if ($type == 1 || $type == 2 || $type == 3 || $type == 36 || $type == 37) {
 $tmp = $HI["ta"];
 $tmp["rows"] = $CN_TEXT_ROWS;
 $tmp["cols"] = $CN_TEXT_COLS;
 $tmp["utf8"] = true;
 
 $varname = "p".$id."_a";
 $f_varname = "f_p".$id."_a";
 $tmp["var"] = $varname;
 if ($clear_vars) {
 global $$varname, $$f_varname;
 $$varname ='';
 $$f_varname = '';
 }
 $tmp["optional"] = $optional;
 $tmp["class"] = "cnTagPart_" . $keyword;
 
 if (is_text_type($type) && $info_int) {
 unset($tmp["regid"]);
 $tmp["regex"] = get_regex_by_id($info_int);
 $tmp["error"] = get_regex_description($info_int);
 }

 
 $vars[] = $tmp["var"];
 $p[$partorder][] = $tmp;
 }


 if ($type == 10 || $type == 21 || $type == 26 || $type == 27) {
 if (($type == 26 || ($FEATURE["jedit_texttags"] && $type == 10)) && $FEATURE["jedit"]) {
 $tmp = $HI["hidden"];
 $varname = "p".$id."_a";
 $f_varname = "f_p".$id."_a";
 $tmp["var"] = $varname;
 if ($clear_vars) {
 global $$varname, $$f_varname;
 $$varname ='';
 $$f_varname = '';
 }
 $tmp["optional"] = $optional;
 $tmp["class"] = "cnTagPart_" . $keyword;
 if (!$JEDIT_FIELDS) $JEDIT_FIELDS = Array();
 $JEDIT_FIELDS[] = "j_".$tmp["var"];
 } else {
 if ($FEATURE["dhtml_texttags"] || $type == 27) $tmp = $HI["dhtmledit"];
 else $tmp = $HI["ta"];
 $tmp["rows"] = $CN_TEXTLONG_ROWS;
 $tmp["cols"] = $CN_TEXTLONG_COLS;
 $tmp["utf8"] = true;
 $varname = "p".$id."_a";
 $f_varname = "f_p".$id."_a";
 $tmp["var"] = $varname;
 if ($clear_vars) {
 global $$varname, $$f_varname;
 $$varname ='';
 $$f_varname = '';
 }
 $tmp["optional"] = $optional;
 $tmp["class"] = "cnTagPart_" . $keyword;
 }
 

 
 if (is_text_type($type) && $info_int) {
 unset($tmp["regid"]);
 $tmp["regex"] = get_regex_by_id($info_int);
 $tmp["error"] = get_regex_description($info_int);
 }

 $vars[] = $tmp["var"];
 $p[$partorder][] = $tmp;

 
 $tmp = $HI["img"];
 $varname = "p_msconvert";
 $f_varname = "f_p_msconvert";
 $f_value = "f_p".$id."_a";
 $tmp["var"] = $varname;
 if ($clear_vars) {
 global $$varname, $$f_varname, $$f_value;
 $$varname ='';
 $$f_varname = '';
 $$f_value = '';
 }
 $tmp["value"] = $f_value;
 $tmp["label"] = i18n('ms_word_import');
 $tmp["src"] = $ICO_WORD;
 $tmp["msconvert"] = 1;
 $p[$partorder]["button"] = $tmp;

 
 $tmp = $HI["img"];
 $varname = "p_spellcheck";
 $f_varname = "f_p_spellcheck";
 $f_value = "f_p".$id."_b";
 $tmp["var"] = $varname;
 if ($clear_vars) {
 global $$varname, $$f_varname, $$f_value;
 $$varname ='';
 $$f_varname = '';
 $$f_value = '';
 }
 $tmp["value"] = $f_value;
 $tmp["label"] = i18n('spellcheck');
 $tmp["src"] = $ICO_SPELL;
 $tmp["spellcheck"] = 1;
 $p[$partorder]["spell"] = $tmp;

 }


 if ($type == 4) {
 
 
 $tmp = $HI["img"];
 $varname = "p_clear";
 $f_varname = "f_p_clear";
 $f_value = "f_p".$id."_d";
 $tmp["var"] = $varname;
 $postClearVar = $varname.$f_value.'_x';
 global $$postClearVar;
 if ( $$postClearVar ){
 $clearThatStuff = true;
 } else {
 $clearThatStuff = false;
 }
 
 $tmp["value"] = $f_value;
 $tmp["label"] = i18n('clear');
 $tmp["src"] = $ICO_PAGE_OFF;
 if ($FEATURE['url_page_clear']) {
 $p[$partorder]["clear"] = $tmp;
 }

 
 $tmp = $HI["hidden"];
 $varname = "p".$id."_a";
 $f_varname = "f_p".$id."_a";
 $tmp["var"] = $varname;
 if ($clear_vars || $clearThatStuff ) {
 global $$varname, $$f_varname, $faction;
 $$varname ='';
 $$f_varname = '';
 $faction = 'apply';
 }

 $tmp["regid"] = 1;
 $tmp["error"] = i18n("Empty selection for internal link.") ;
 $tmp["optional"] = true;
 $tmp["class"] = "cnTagPart_" . $keyword;
 
 $vars[] = $tmp["var"];
 $p[$partorder]["intern"] = $tmp;

 
 $tmp = $HI["disabled"];
 $varname = "p".$id;
 $f_varname = "f_p".$id;
 $f_value = "f_p".$id;
 $tmp["var"] = $varname;
 $tmp["label"] = i18n('324.internal');
 $p[$partorder]["disabled"] = $tmp;
 if ($clear_vars || $clearThatStuff ) {
 global $$varname, $$f_varname, $$f_value;
 $$varname ='';
 $$f_varname = '';
 $$f_value = '';
 }
 
 $tmp["value"] = $f_value;
 
 
 $tmp = $HI["img"];
 $varname = "p_minipage";
 $f_varname = "f_p_minipage";
 $f_value = "f_p".$id."_a";
 $tmp["var"] = $varname;
 if ($clear_vars) {
 global $$varname, $$f_varname, $$f_value;
 $$varname ='';
 $$f_varname = '';
 $$f_value = '';
 }
 $tmp["value"] = $f_value;

 $tmp["label"] = i18n('cn_minibrowser');
 $tmp["src"] = $ICO_MINI;
 $tmp["minibut"] = 1;
 $p[$partorder]["button"] = $tmp;

 
 $tmp = $HI["any"];
 $varname = "p".$id."_b";
 $f_varname = "f_p".$id."_b";
 $tmp["var"] = $varname;
 if ($clear_vars) {
 global $$varname, $$f_varname;
 $$varname ='';
 $$f_varname = '';
 }
 $tmp["regid"] = 15;
 $tmp["optional"] = true;
 $tmp["error"] = i18n('Bitte eine gueltige URL eingeben');
 
 $vars[] = $tmp["var"];
 $tmp["label"] = i18n('325.external');
 $p[$partorder]["extern"] = $tmp;

 
 $tmp = $HI["radio"];
 $varname = "p".$id."_c";
 $f_varname = "f_p".$id."_c";
 $tmp["var"] = $varname;
 if ($clear_vars) {
 global $$varname, $$f_varname;
 $$varname ='';
 $$f_varname = '';
 }
 if ( $clearThatStuff) {
 global $$f_varname;
 $$f_varname = 'b';
 }

 $tmp["label"] = $name;
 $tmp["list"] = array("a"=>"","b"=>"");
 $tmp["optional"] = $optional;
 $tmp["class"] = "cnTagPart_" . $keyword;

 
 $vars[] = $tmp["var"];
 $p[$partorder]["radio"] = $tmp;
 }

 
 if ($type == 5) {
 $sql = "SELECT id, name, LOWER(name) AS l_name FROM globaltag ORDER BY l_name";
 $rs = query($sql,true);
 $rs = reduce_array($rs["arr"],"id","name");
 if (!$rs) $rs = Array();
 $tmp = $HI["sel"];
 $varname = "p".$id."_a";
 $f_varname = "f_p".$id."_a";
 $tmp["var"] = $varname;
 if ($clear_vars) {
 global $$varname, $$f_varname;
 $$varname ='';
 $$f_varname = '';
 }
 $tmp["list"] = $rs;
 $tmp["optional"] = $optional;
 $tmp["class"] = "cnTagPart_" . $keyword;
 
 
 $vars[] = $tmp["var"];
 $p[$partorder]["tag"] = $tmp;
 }

 
 if ($type == 6) {

 
 $tmp = $HI["img"];
 $varname = "p_clear";
 $f_varname = "f_p_clear";
 $f_value = "f_p".$id."_d";
 $tmp["var"] = $varname;
 $postClearVar = $varname.$f_value.'_x';
 global $$postClearVar;
 if ( $$postClearVar ){
 $clearThatStuff = true;
 } else {
 $clearThatStuff = false;
 }
 
 $tmp["value"] = $f_value;
 $tmp["label"] = i18n('clear');
 $tmp["src"] = $ICO_PAGE_OFF;
 $tmp["class"] = "cnTagPart_" . $keyword;
 
 if ($FEATURE['url_image_clear'] && $optional) {
 $p[$partorder]["clear"] = $tmp;
 }


 
 $tmp = $HI["hidden"];
 $varname = "p".$id."_a";
 $f_varname = "f_p".$id."_a";
 $tmp["var"] = $varname;
 if ($clear_vars || $clearThatStuff) {
 global $$varname, $$f_varname, $faction;
 $$varname ='';
 $$f_varname = '';
 $faction = 'apply';
 }
 $tmp["regid"] = 1;
 $tmp["error"] = i18n('an_element_must_be');
 $tmp["optional"] = $optional;
 $tmp["class"] = "cnTagPart_" . $keyword;
 
 
 $vars[] = $tmp["var"];
 $tmp["label"] = i18n('326.part_genform.func.php_unknown');
 $p[$partorder]["intern"] = $tmp;

 
 $tmp = $HI["disabled"];
 $varname = "p".$id;
 $f_varname = "f_p".$id;
 $f_value = "f_p".$id; 
 $tmp["var"] = $varname;
 $tmp["optional"] = $optional;
 $tmp["disabled_notoptional"] = true;
 $tmp["class"] = "cnTagPart_" . $keyword;
 
 if ($clear_vars || $clearThatStuff) {
 global $$varname, $$f_varname, $f_value;
 $$varname ='';
 $$f_varname = '';
 $$f_value = '';
 }
 $tmp["value"] = $f_value;
 $p[$partorder]["disabled"] = $tmp;

 
 $tmp = $HI["img"];
 $varname = "p_miniimage";
 $f_varname = "f_p_miniimage";
 $f_value = "f_p".$id."_a";
 $tmp["var"] = $varname;
 if ($clear_vars || $clearThatStuff) {
 global $$varname, $$f_varname, $$f_value;
 $$varname ='';
 $$f_varname = '';
 $$f_value = '';
 }
 $tmp["value"] = $f_value;
 $tmp["label"] = i18n('cn_minibrowser');
 $tmp["src"] = $ICO_MINI;
 $tmp["minibut"] = 1;
 $p[$partorder]["button"] = $tmp;
 }

 

 
 if ($type == 8 || $type == 14 || $type == 38 ) {

 
 
 $tmp = $HI["img"];
 $varname = "p_clear";
 $f_varname = "f_p_clear";
 $f_value = "f_p".$id."_d";
 $tmp["var"] = $varname;
 $postClearVar = $varname.$f_value.'_x';
 global $$postClearVar;
 if ( $$postClearVar ){
 $clearThatStuff = true;
 } else {
 $clearThatStuff = false;
 }
 
 $tmp["value"] = $f_value;
 $tmp["label"] = i18n('clear');
 $tmp["src"] = $ICO_PAGE_OFF;
 if ($FEATURE['url_file_clear'] && $optional) {
 $p[$partorder]["clear"] = $tmp;
 }

 
 $tmp = $HI["hidden"];
 $varname = "p".$id."_a";
 $f_varname = "f_p".$id."_a";
 $tmp["var"] = $varname;
 if ($clear_vars || $clearThatStuff) {
 global $$varname, $$f_varname, $faction;
 $$varname ='';
 $$f_varname = '';
 $faction = 'apply';
 }
 $tmp["regid"] = 1;
 $tmp["error"] = i18n('an_element_must_be');
 $tmp["optional"] = $optional;
 $tmp["class"] = "cnTagPart_" . $keyword;
 
 $vars[] = $tmp["var"];
 $tmp["label"] = i18n('324.internal');
 $p[$partorder]["intern"] = $tmp;

 
 $tmp = $HI["disabled"];
 $varname = "p".$id;
 $f_varname = "f_p".$id;
 $f_value = "f_p".$id;
 $tmp["var"] = $varname;
 if ($clear_vars || $clearThatStuff) {
 global $$varname, $$f_varname, $$f_value;
 $$varname ='';
 $$f_varname = '';
 $$f_value = '';
 }
 $tmp["value"] = $f_value;
 $p[$partorder]["disabled"] = $tmp;

 
 $tmp = $HI["img"];
 $varname = "p_minifile";
 $f_varname = "f_p_minifile";
 $f_value = "f_p".$id."_a";
 $tmp["var"] = $varname;
 if ($clear_vars) {
 global $$varname, $$f_varname, $$f_value;
 $$varname ='';
 $$f_varname = '';
 $$f_value = '';
 }
 $tmp["value"] = $f_value;
 $tmp["label"] = i18n('cn_minibrowser');
 $tmp["src"] = $ICO_MINI;
 $tmp["minibut"] = 1;
 $p[$partorder]["button"] = $tmp;
 }

 
 if ($type == 25 || $type == 39 ) {
 
 $tmp = $HI["img"];
 $varname = "p_clear";
 $f_varname = "f_p_clear";
 $f_value = "f_p".$id."_d";
 $tmp["var"] = $varname;
 $postClearVar = $varname.$f_value.'_x';
 global $$postClearVar;
 if ( $$postClearVar ){
 $clearThatStuff = true;
 } else {
 $clearThatStuff = false;
 }

 $tmp["value"] = $f_value;
 $tmp["label"] = i18n('clear');
 $tmp["src"] = $ICO_PAGE_OFF;
 if ($FEATURE['url_folder_clear']) {
 $p[$partorder]["clear"] = $tmp;
 }

 
 $tmp = $HI["hidden"];
 $varname = "p".$id."_a";
 $f_varname = "f_p".$id."_a";
 $tmp["var"] = $varname;
 if ($clear_vars || $clearThatStuff) {
 global $$varname, $$f_varname, $faction;
 $$varname ='';
 $$f_varname = '';
 $faction = 'apply';
 }
 $tmp["regid"] = 1;
 $tmp["error"] = i18n('an_element_must_be');
 $tmp["optional"] = $optional;
 
 $vars[] = $tmp["var"];
 $tmp["label"] = i18n('324.internal');
 $p[$partorder]["intern"] = $tmp;

 
 $tmp = $HI["disabled"];
 $varname = "p".$id;
 $f_varname = "f_p".$id;
 $tmp["var"] = $varname;
 if ($clear_vars || $clearThatStuff) {
 global $$varname, $$f_varname;
 $$varname ='';
 $$f_varname = '';
 }
 $p[$partorder]["disabled"] = $tmp;

 
 $tmp = $HI["img"];
 $varname = "p_minifolder";
 $f_varname = "f_p_minifolder";
 $f_value = "f_p".$id."_a";
 $tmp["var"] = $varname;
 if ($clear_varsi || $clearThatStuff) {
 global $$varname, $$f_varname, $$f_value;
 $$varname ='';
 $$f_varname = '';
 $$f_value = '';
 }
 $tmp["value"] = $f_value;
 $tmp["label"] = i18n('cn_minibrowser');
 $tmp["src"] = $ICO_MINI;
 $tmp["minibut"] = 1;
 $p[$partorder]["button"] = $tmp;
 }

 
 if ($type == 9) {
 $tmp = $HI["text"];
 $varname = "p".$id."_a";
 $f_varname = "f_p".$id."_a";
 $tmp["var"] = $varname;
 if ($clear_vars) {
 global $$varname, $$f_varname;
 $$varname ='';
 $$f_varname = '';
 }
 $tmp["optional"] = $optional;
 $tmp["size"] = $CN_TEXTSHORT_SIZE;
 $tmp["class"] = "cnTagPart_" . $keyword;
 
 
 if (is_text_type($type) && $info_int) {
 unset($tmp["regid"]);
 $tmp["regex"] = get_regex_by_id($info_int);
 $tmp["error"] = get_regex_description($info_int);
 }

 
 $vars[] = $tmp["var"];
 $p[$partorder][] = $tmp;
 }

 
 if ($type == 11) {
 $tmp = $HI["hidden"];
 $varname = "p".$id."_a";
 $f_varname = "f_p".$id."_a";
 $tmp["var"] = $varname;
 if ($clear_vars) {
 global $$varname, $$f_varname;
 $$varname ='';
 $$f_varname = '';
 }
 $tmp["regid"] = REG_NOTEMPTY;
 $tmp["error"] = "";
 $tmp["optional"] = $optional;
 
 $vars[] = $tmp["var"];
 $tmp["label"] = i18n('tag');
 $p[$partorder]["intern"] = $tmp;

 
 $tmp = $HI["disabled"];
 $varname = "p".$id;
 $f_varname = "f_p".$id;
 $tmp["var"] = $varname;
 if ($clear_vars) {
 global $$varname, $$f_varname;
 $$varname ='';
 $$f_varname = '';
 }
 $p[$partorder]["disabled"] = $tmp;
 
 
 $tmp = $HI["img"];
 $tmp["var"] = "p_minipagetag";
 $varname = "p_minipagetag";
 $f_varname = "f_p_minipagetag";
 $f_value = "f_p".$id."_a";
 $tmp["var"] = $varname;
 if ($clear_vars) {
 global $$varname, $$f_varname, $$f_value;
 $$varname ='';
 $$f_varname = '';
 $$f_value = '';
 }
 $tmp["value"] = $f_value;
 $tmp["label"] = i18n('cn_minibrowser');
 $tmp["src"] = $ICO_MINI;
 $tmp["minibut"] = 1;
 $tmp["class"] = "cnTagPart_" . $keyword;
 $p[$partorder]["button"] = $tmp;
 }

 
 if ($type == 20) {
 $tmp = $HI["hidden"];
 $varname = "p".$id."_a";
 $f_varname = "f_p".$id."_a";
 $tmp["var"] = $varname;
 if ($clear_vars) {
 global $$varname, $$f_varname;
 $$varname ='';
 $$f_varname = '';
 }
 $tmp["regid"] = REG_NOTEMPTY;
 $tmp["error"] = "";
 $tmp["optional"] = $optional;
 $tmp["class"] = "cnTagPart_" . $keyword;
 
 
 $vars[] = $tmp["var"];
 $tmp["label"] = i18n('tag');
 $p[$partorder]["intern"] = $tmp;

 
 $tmp = $HI["disabled"];
 $varname = "p".$id;
 $f_varname = "f_p".$id;
 $tmp["var"] = $varname;
 if ($clear_vars) {
 global $$varname, $$f_varname;
 $$varname ='';
 $$f_varname = '';
 }
 $p[$partorder]["disabled"] = $tmp;

 
 $tmp = $HI["img"];
 $tmp["var"] = "p_minitemplatetag";
 $varname = "p_minitemplatetag";
 $f_varname = "f_p_minitemplatetag";
 $f_value = "f_p".$id."_a";
 $tmp["var"] = $varname;
 if ($clear_vars) {
 global $$varname, $$f_varname, $$f_value;
 $$varname ='';
 $$f_varname = '';
 $$f_value = '';
 }
 $tmp["value"] = $f_value;
 $tmp["label"] = i18n('cn_minibrowser');
 $tmp["src"] = $ICO_MINI;
 $tmp["minibut"] = 1;
 $p[$partorder]["button"] = $tmp;
 }

 
 if ($type == 23) {
 if (strlen($info_text) > 0) $info_text_tmp = explode(';',$info_text);
 if (strlen($info_text_tmp[0]) > 0 && $info_text_tmp[0] != 0) $cols = $info_text_tmp[0];
 if (strlen($info_text_tmp[1]) > 0 && $info_text_tmp[1] != 0) $rows = $info_text_tmp[1];
 if (strlen($info_text_tmp[2]) > 0 && $info_text_tmp[2] != 0) $cid = $info_text_tmp[2];

 
 $tmp = $HI["text"];
 $varname = "p".$id."_a";
 $f_varname = "f_p".$id."_a";
 $tmp["var"] = $varname;
 if ($cols) {
 global $$varname;
 $tmp["disabled"] = true;
 $$varname = $cols;
 }
 if ($clear_vars) {
 global $$varname, $$f_varname;
 $$varname ='';
 $$f_varname = '';
 }
 $tmp["regid"] = 22;
 $tmp["label"] = i18n('number of columns');
 
 $vars[] = $tmp["var"];
 $p[$partorder]["cols"] = $tmp;

 
 $tmp = $HI["text"];
 $varname = "p".$id."_b";
 $f_varname = "f_p".$id."_b";
 $tmp["var"] = $varname;
 if ($rows) {
 global $$varname;
 $tmp["disabled"] = true;
 $$varname = $rows;
 }
 if ($clear_vars) {
 global $$varname, $$f_varname;
 $$varname ='';
 $$f_varname = '';
 }
 $tmp["label"] = i18n('number of rows');
 
 $vars[] = $tmp["var"];
 $p[$partorder]["rows"] = $tmp;

 $where = get_visible_constructs("construct.id",$NODE_ID);

 
 if ($cid && $cid > 0) $where .= " OR construct.id = ".sqlf_tl_num($cid);
 $sql = "SELECT value AS name, construct.id, LOWER(value) AS l_value FROM construct LEFT JOIN dicuser ON (dicuser.output_id = construct.name_id AND dicuser.language_id = ".sqlf_tl_num($LANGUAGE).") WHERE $where AND construct.intext = 1 ORDER BY l_value";
 $rs = query($sql);

 $constructs = $rs["arr"];
 $constructs = reduce_array($constructs,"id","name");
 if (!is_array($constructs)) $constructs = Array();

 
 $tmp = $HI["sel"];
 $tmp["list"] = $constructs;
 $varname = "p".$id."_c";
 $f_varname = "f_p".$id."_c";
 $tmp["var"] = $varname;

 if ($cid && $cid > 0) {
 global $$varname;
 $tmp["readonly"] = true;
 $$varname = $cid;
 }
 if ($clear_vars) {
 global $$varname, $$f_varname;
 $$varname ='';
 $$f_varname = '';
 }
 $tmp["label"] = i18n('cell tagtype');
 
 $vars[] = $tmp["var"];
 $p[$partorder]["construct"] = $tmp;
 }

 
 if ($type == 12) {
 
 $tmp = $HI["text"];
 $varname = "p".$id."_a";
 $f_varname = "f_p".$id."_a";
 $tmp["var"] = $varname;
 if ($clear_vars) {
 global $$varname, $$f_varname;
 $$varname ='';
 $$f_varname = '';
 }
 $tmp["regid"] = 22;
 $tmp["label"] = i18n('number of columns');
 
 $vars[] = $tmp["var"];
 $p[$partorder]["cols"] = $tmp;

 
 $varname = "p".$id."_b";
 $f_varname = "f_p".$id."_b";
 $tmp["var"] = $varname;
 if ($clear_vars) {
 global $$varname, $$f_varname;
 $$varname ='';
 $$f_varname = '';
 }
 $tmp["label"] = i18n('number of rows');
 
 $vars[] = $tmp["var"];
 $p[$partorder]["rows"] = $tmp;

 
 $tmp = $HI["checkbox"];
 $varname = "p".$id."_c";
 $f_varname = "f_p".$id."_c";
 $tmp["var"] = $varname;
 $tmp["class"] = "cnTagPart_" . $keyword;
 
 if ($clear_vars) {
 global $$varname, $$f_varname;
 $$varname ='';
 $$f_varname = '';
 }
 $tmp["label"] = "mit Überschriftszeile";
 $vars[] = $tmp["var"];
 $p[$partorder]["th"] = $tmp;

 
 $tmp = $HI["sel"];
 $varname = "p".$id."_d";
 $f_varname = "f_p".$id."_d";
 $tmp["var"] = $varname;
 if ($clear_vars) {
 global $$varname, $$f_varname;
 $$varname ='';
 $$f_varname = '';
 }
 $tmp["label"] = i18n('cell tagtype');
 $sql = "SELECT construct.id, dicuser.value AS name, LOWER(dicuser.value) AS l_name FROM construct, dicuser WHERE
construct.name_id = dicuser.output_id AND dicuser.language_id = ".sqlf_tl_num($LANGUAGE)." ORDER BY l_name";
 $rs = query($sql);
 $rs = reduce_array($rs["arr"],"id","name");
 if (!is_array($rs)) $rs = Array();
 $tmp["list"] = $rs;
 $tmp["optional"] = true;
 $tmp["class"] = "cnTagPart_" . $keyword;
 $vars[] = $tmp["var"];
 $p[$partorder]["ctd"] = $tmp;

 
 $varname = "p".$id."_e";
 $f_varname = "f_p".$id."_e";
 $tmp["var"] = $varname;
 if ($clear_vars) {
 global $$varname, $$f_varname;
 $$varname ='';
 $$f_varname = '';
 }
 $tmp["label"] = i18n('header tagtype');
 $tmp["optional"] = true;
 $vars[] = $tmp["var"];
 $p[$partorder]["cth"] = $tmp;

 
 $tmp = $HI["text"];
 $varname = "p".$id."_f";
 $f_varname = "f_p".$id."_f";
 $tmp["var"] = $varname;
 if ($clear_vars) {
 global $$varname, $$f_varname;
 $$varname ='';
 $$f_varname = '';
 }
 $tmp["label"] = "Formatierung der Zellen gerader Zeilen";
 $tmp["optional"] = true;
 $vars[] = $tmp["var"];
 $p[$partorder]["f_td_ev"] = $tmp;

 
 $varname = "p".$id."_g";
 $f_varname = "f_p".$id."_g";
 $tmp["var"] = $varname;
 if ($clear_vars) {
 global $$varname, $$f_varname;
 $$varname ='';
 $$f_varname = '';
 }
 $tmp["label"] = "Formatierung der Zellen ungerader Zeilen";
 $tmp["optional"] = true;
 $vars[] = $tmp["var"];
 $p[$partorder]["f_td_odd"] = $tmp;

 
 $varname = "p".$id."_h";
 $f_varname = "f_p".$id."_h";
 $tmp["var"] = $varname;
 if ($clear_vars) {
 global $$varname, $$f_varname;
 $$varname ='';
 $$f_varname = '';
 }
 $tmp["label"] = "Formatierung der Überschriftszellen";
 $tmp["optional"] = true;
 $vars[] = $tmp["var"];
 $p[$partorder]["f_th"] = $tmp;

 
 $varname = "p".$id."_i";
 $f_varname = "f_p".$id."_i";
 $tmp["var"] = $varname;
 if ($clear_vars) {
 global $$varname, $$f_varname;
 $$varname ='';
 $$f_varname = '';
 }
 $tmp["label"] = "Formatierung der Tabelle";
 $tmp["optional"] = true;
 $vars[] = $tmp["var"];
 $p[$partorder]["f_table"] = $tmp;

 }
 
 if ($type == 13) {
 
 $tmp = $HI["hidden"];
 $varname = "p".$id."_a";
 $f_varname = "f_p".$id."_a";
 $tmp["var"] = $varname;
 if ($clear_vars) {
 global $$varname, $$f_varname;
 $$varname ='';
 $$f_varname = '';
 }
 $tmp["regid"] = 1;
 $tmp["error"] = "";
 $tmp["optional"] = true;
 $tmp["class"] = "cnTagPart_" . $keyword;
 
 
 $vars[] = $tmp["var"];
 $p[$partorder]["ds"] = $tmp;

 if ( $FEATURE["dssource"] ) {

 
 $tmp = $HI["ta"];
 $varname = "p".$id."_b";
 $f_varname = "f_p".$id."_b";
 $tmp["var"] = $varname;
 if ($clear_vars) {
 global $$varname, $$f_varname;
 $$varname ='';
 $$f_varname = '';
 }
 $tmp["error"] = "";
 $tmp["optional"] = true;
 $tmp["cols"] = 35;
 $tmp["rows"] = 10;
 
 $vars[] = $tmp["var"];
 $p[$partorder]["dssource"] = $tmp;
 
 
 $tmp = $HI["checkbox"];
 $varname = "p".$id."_c";
 $f_varname = "f_p".$id."_c";
 $tmp["var"] = $varname;
 $tmp["label"] = i18n("changeable");
 if ($clear_vars) {
 global $$varname, $$f_varname;
 $$varname ='';
 $$f_varname = '';
 }
 
 $vars[] = $tmp["var"];
 $p[$partorder]["dssourcechangeable"] = $tmp;

 }
































 }

 
 if ($type == 15 || $type == 16 || $type == 17) {
 $tmp = $HI["ta"];
 global $CN_LIST_INPUT_ROWS, $CN_LIST_INPUT_COLS;
 $tmp["rows"] = $CN_LIST_INPUT_ROWS;
 $tmp["cols"] = $CN_LIST_INPUT_COLS;
 $varname = "p".$id."_a";
 $f_varname = "f_p".$id."_a";
 $tmp["var"] = $varname;
 if ($clear_vars) {
 global $$varname, $$f_varname;
 $$varname ='';
 $$f_varname = '';
 }
 $tmp["optional"] = $optional;
 $tmp["class"] = "cnTagPart_" . $keyword;
 
 $vars[] = $tmp["var"];
 $p[$partorder]["text"] = $tmp;

 $listkind[0] = i18n( "Bullets" );
 $listkind[1] = i18n( "Numbers" ); 
 if ($type == 15) {
 $tmp = $HI["sel"];
 $tmp["list"] = $listkind;
 $tmp["var"] = "p".$id."_b";
 $tmp["label"] = i18n( "Listtype" ); 
 $vars[] = $tmp["var"];
 $p[$partorder]["order"] = $tmp;
 }
 }

 
 if ($type == 18 || $type == 19 || $type == 24) {

 if ($type == 18) {
 $size[0] = 70;
 $size[1] = 120;
 $size[2] = 180;
 }
 if ($type == 19) {
 $size[0] = 110;
 $size[1] = 160;
 $size[2] = 220;
 }
 if ($type == 24) {
 $size["zellehell"] = "Hell";
 $size["zelledunkel"] = "Dunkel";
 $size["headernegativ"] = "&Uuml;berschrift";
 $size["farblos"] = "Farblos";
 }
 $tmp = $HI["sel"];
 $tmp["list"] = $size;
 $varname = "p".$id."_a";
 $f_varname = "f_p".$id."_a";
 $tmp["var"] = $varname;
 if ($clear_vars) {
 global $$varname, $$f_varname;
 $$varname ='';
 $$f_varname = '';
 }
 $tmp["optional"] = $optional;
 $tmp["class"] = "cnTagPart_" . $keyword;
 $vars[] = $tmp["var"];
 $p[$partorder]["sel"] = $tmp;
 }

 
 if ($type == 29 || $type == 30) {
 $tmp = $HI["sel"];
 $varname = "p".$id."_a";
 $f_varname = "f_p".$id."_a";
 $sessionvar = $varname."_SESSION";
 global $$varname, $$f_varname, $$sessionvar;
 if ( !is_array($$sessionvar) ) $$sessionvar = array();
 ${$sessionvar}["allkeys"] = array();
 $tmp["var"] = $varname;
 if ($clear_vars) {
 $$varname = "";
 $$f_varname = "";
 }
 
 node_class( "sourcefactory" );
 $list = SourceFactory::loadSourceList( $info_int );
 $sList = array();
 global $USER_ID;
 $useperm = perm( $USER_ID, T_DATASOURCE, $info_int, 8 );
 $maxValLength = 0;
 foreach ( $list as $key=>$val )
 {
 if ( $FEATURE["datasource_perm_use"] && $useperm )
 $_canAdd = perm($USER_ID, T_DATASOURCE_ELEMENT, $key, 0 ) || $key == $$varname || $key == $$f_varname;
 else
 $_canAdd = true;

 if ( $_canAdd ) {
 $sList[$key] = $val["key"];
 ${$sessionvar}["allkeys"][] = $key; 
 $maxValLength = max($maxValLength, strlen($val["key"]));
 
 }

 }
 $tmp["list"] = $sList; 
 $tmp["optional"] = $optional;
 $tmp["class"] = "cnTagPart_" . $keyword;
 $tmp["maxlength"] = $maxValLength;
 if ($type == 30) {
 global $MULTIPLE_SELECT_SIZE;
 if ( isset($MULTIPLE_SELECT_SIZE) )
 $_mssize = $MULTIPLE_SELECT_SIZE;
 else
 $_mssize = 10;
 $tmp["multiple"] = true;
 $tmp["size"] = $_mssize;
 $tmp["force"] = false;
 }
 $vars[] = $tmp["var"];
 $p[$partorder]["sel"] = $tmp;
 }

 
 if ($type == 31) {
 $tmp = $HI["checkbox"];
 $varname = "p".$id."_a";
 $f_varname = "f_$varname";
 $tmp["var"] = $varname;
 $tmp["class"] = "cnTagPart_" . $keyword;
 
 if ($clear_vars) {
 global $$varname, $$f_varname;
 $$varname = "";
 $$f_varname = "";
 }
 $vars[] = $tmp["var"];
 $p[$partorder]["checkbox"] = $tmp;
 }

 
 if ($type == 22) {
 $tmp = $HI["filepath"];
 $varname = "p".$id."_a";
 $f_varname = "f_p".$id."_a";
 $tmp["var"] = $varname;
 if ($clear_vars) {
 global $$varname, $$f_varname;
 $$varname ='';
 $$f_varname = '';
 }
 $tmp["regid"] = 30;
 $tmp["optional"] = true;
 $tmp["class"] = "cnTagPart_" . $keyword;
 
 $vars[] = $tmp["var"];
 $p[$partorder]["filepath"] = $tmp;
 }


 if ($type == 32) {
 
 $sourceFkt = "genDatasourceWizard";
 $tmp = $HI["hidden"];
 $varname = "p".$id."_$sourceFkt";
 $f_varname = "f_p".$id."_$sourceFkt";
 $tmp["var"] = $varname;
 if ($clear_vars) {
 global $$varname, $$f_varname;
 $$varname ='';
 $$f_varname = '';
 }
 $tmp["regid"] = 1;
 $tmp["optional"] = true;
 $tmp["class"] = "cnTagPart_" . $keyword;
 
 
 $vars[] = $tmp["var"];
 $tmp["label"] = i18n( "Datasource" );
 $p[$partorder]["intern"] = $tmp;

 
 $tmp = $HI["disabled"];
 $tmp["var"] = "p".$id;
 $p[$partorder]["disabled"] = $tmp;
 
 
 $tmp = $HI["img"];
 $varname = "p_selectform";
 $f_varname = "f_p_selectform";
 $f_value = "f_p".$id."_$sourceFkt";
 $tmp["var"] = $varname;
 if ($clear_vars) {
 global $$varname, $$f_varname, $$f_value;
 $$varname ='';
 $$f_varname = '';
 $$f_value = '';
 }
 $tmp["value"] = $f_value;
 
 $tmp["label"] = i18n("Datasource");
 $tmp["src"] = $ICO_MINI;
 $tmp["formbut"] = $info_int;
 $tmp["class"] = "cnTagPart_" . $keyword;
 $p[$partorder]["button"] = $tmp;
 }

 if (substr($keyword, 0, 3) == "tr." || substr($keyword, 0, 3) == "td.") {
 $tmp = $HI["checkbox"];
 $tmp["var"] = "p".$id."_cl";
 $tmp["label"] = i18n("Clear values");
 $p[$partorder]["tabclear"] = $tmp;
 }
}

$ret["parts"] = $p;
$ret["vars"] = $vars;

return $ret;

}
?>
